/*************************************************************************
*	"partition.h"
*-------------------------------------------------------------------------
*	$Id: partition.h,v 1.3 2002/10/15 04:07:50 cvsuser Exp $
*************************************************************************/
#ifndef	PARTITION_H_INCLUDED
#define	PARTITION_H_INCLUDED

#include	<windows.h>

#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

typedef struct
{
	WORD				wSectorSize;
	BYTE				bAllocUnit;
	WORD				wReserveSector;
	BYTE				bFatNumber;
	WORD				wRootEntry;
	WORD				wSectorVolume;
	BYTE				bMediaDescriptor;
	WORD				wFatSector;
	WORD				wSectorPerTrack;
	WORD				wHeadNumber;
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;
	WORD				dummy1;
	BYTE				dummy2;
	DWORD				dwSerialNo;
	BYTE				sVolumeLabel[11];
	BYTE				sFileSystem[8];
} BPBDATA;	/* 51 bytes */

typedef struct			/* FAT32 BPB */
{
	WORD				wSectorSize;
	BYTE				bAllocUnit;
	WORD				wReserveSector;
	BYTE				bFatNumber;
	WORD				wRootEntry;			/* always 0x00 */
	WORD				wSectorVolume;
	BYTE				bMediaDescriptor;
	WORD				wFatSector;			/* always 0x00 */
	WORD				wSectorPerTrack;
	WORD				wHeadNumber;
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;
	DWORD				dwBigFatSector;		/* like wFatSector for FAT32 */
	WORD				wExtFlags;
	WORD				wFsVer;				/* file system version */
	DWORD				dwRootCluster;		/* start cluster for root directory */
	WORD				wFsInfo;			/* filesystem info structure sector */
	WORD				wBackupBootSector;
	BYTE				dumy1[12];
	BYTE				bDrvNo;				/* ==0x80 primary */
	BYTE				dumy2;
	BYTE				bBootSignature;		/* always 0x29 */
	DWORD				dwSerialNo;
	BYTE				sVolumeLabel[11];
	BYTE				sFileSystem[8];
} BF_BPB;

struct NTFSBootBlock
{
	BYTE				jump[3];
	BYTE				oem_id[8];
	WORD				wSectorSize;
	BYTE				bAllocUnit;			/* sectors per cluster */
	WORD				wReserveSector;
	BYTE				bFatNumber;			/* always 0 */
	WORD				wRootEntry;			/* always 0 */
	WORD				wSectorVolume;		/* not use */
	BYTE				bMediaDescriptor;
	WORD				wFatSector;			/* 0 sector per fat */
	WORD				wSectorPerTrack;	/* sector per track */
	WORD				wHeadNumber;		/* heads per cylinder */
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;	/* not use */
	DWORD				dwBigFatSector;		/* not use */
	DWORD64				totalSectors;
	DWORD64				lcnMFT;				/* Logical Cluster Number for the file $MFT */
	DWORD64				lcnMFTMirror;		/* Logical Cluster Number for the file $MFTMirr */
	DWORD				dwFileRecSeg;		/* Clusters Per File Record Segment */
	DWORD				dwIndexBlock;		/* Clusters Per Index Block */
	DWORD64				volumeSerialNo;
	DWORD				dwChecksum;			/* checksum */
};

typedef struct
{
	BYTE				bBootFlag;
	BYTE				bUnkown;
	DWORD				dwStartSector;
	DWORD				dwSectorNumber;
	BYTE				reserve[6];
	BYTE				sOsName[16];
	BYTE				sVolumeName[16];
} FMRPARTINF;

typedef struct
{
	BYTE				bBootFlag;
	BYTE				bStartSide;
	BYTE				bStartSector;
	BYTE				bStartCylinder;
	BYTE				bPartType;
	BYTE				bEndSide;
	BYTE				bEndSector;
	BYTE				bEndCylinder;
	DWORD				dwRelativeSector;
	DWORD				dwSectorNumber;
} IBMPARTINF;

#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif

#endif
